function io = mliolist()
%MLIOLIST returns a n-by-3 cell matrix that specifies the IO signal types.
%
% 1st column: name of the signal
% 2st column: subsystems that the signal can be interfaced with
%             ('AnalogInput','AnalogOutput','DigitalIO')
% 3st column: two-element array that contains further Digital IO information
%             1st element - direction of DIO (0: in, 1: out)
%             2nd element - multiline support (0: no, 1: yes)

io = { ...
    'Eye X', 'AnalogInput', [NaN NaN]; ...
    'Eye Y', 'AnalogInput', [NaN NaN]; ...
    'Joystick X', 'AnalogInput', [NaN NaN]; ...
    'Joystick Y', 'AnalogInput', [NaN NaN]; ...
    'Reward', {'AnalogOutput','DigitalIO'}, [1 1]; ...
    'Behavioral Codes', 'DigitalIO', [1 1]; ...
    'Strobe Bit', 'DigitalIO', [1 0]; ...
    'PhotoDiode', 'AnalogInput', [NaN NaN]; ...
    'Eye2 X', 'AnalogInput', [NaN NaN]; ...
    'Eye2 Y', 'AnalogInput', [NaN NaN]; ...
    'Joystick2 X', 'AnalogInput', [NaN NaN]; ...
    'Joystick2 Y', 'AnalogInput', [NaN NaN]; ...
    'Button 1', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 2', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 3', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 4', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 5', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 6', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 7', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 8', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 9', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'Button 10', {'AnalogInput','DigitalIO'}, [0 0]; ...
    'General Input 1', 'AnalogInput', [NaN NaN]; ...
    'General Input 2', 'AnalogInput', [NaN NaN]; ...
    'General Input 3', 'AnalogInput', [NaN NaN]; ...
    'General Input 4', 'AnalogInput', [NaN NaN]; ...
    'General Input 5', 'AnalogInput', [NaN NaN]; ...
    'General Input 6', 'AnalogInput', [NaN NaN]; ...
    'General Input 7', 'AnalogInput', [NaN NaN]; ...
    'General Input 8', 'AnalogInput', [NaN NaN]; ...
    'General Input 9', 'AnalogInput', [NaN NaN]; ...
    'General Input 10', 'AnalogInput', [NaN NaN]; ...
    'General Input 11', 'AnalogInput', [NaN NaN]; ...
    'General Input 12', 'AnalogInput', [NaN NaN]; ...
    'General Input 13', 'AnalogInput', [NaN NaN]; ...
    'General Input 14', 'AnalogInput', [NaN NaN]; ...
    'General Input 15', 'AnalogInput', [NaN NaN]; ...
    'General Input 16', 'AnalogInput', [NaN NaN]; ...
    'Stimulation 1', 'AnalogOutput', [NaN NaN]; ...
    'Stimulation 2', 'AnalogOutput', [NaN NaN]; ...
    'Stimulation 3', 'AnalogOutput', [NaN NaN]; ...
    'Stimulation 4', 'AnalogOutput', [NaN NaN]; ...
    'TTL 1', 'DigitalIO', [1 0]; ...
    'TTL 2', 'DigitalIO', [1 0]; ...
    'TTL 3', 'DigitalIO', [1 0]; ...
    'TTL 4', 'DigitalIO', [1 0]; ...
    'TTL 5', 'DigitalIO', [1 0]; ...
    'TTL 6', 'DigitalIO', [1 0]; ...
    'TTL 7', 'DigitalIO', [1 0]; ...
    'TTL 8', 'DigitalIO', [1 0]; ...
    'TTL 9', 'DigitalIO', [1 0]; ...
    'TTL 10', 'DigitalIO', [1 0]; ...
    'TTL 11', 'DigitalIO', [1 0]; ...
    'TTL 12', 'DigitalIO', [1 0]; ...
    'TTL 13', 'DigitalIO', [1 0]; ...
    'TTL 14', 'DigitalIO', [1 0]; ...
    'TTL 15', 'DigitalIO', [1 0]; ...
    'TTL 16', 'DigitalIO', [1 0]; ...
    'High Frequency 1', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 2', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 3', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 4', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 5', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 6', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 7', 'AnalogInput', [NaN NaN]; ...
    'High Frequency 8', 'AnalogInput', [NaN NaN]; ...
    };
end
